/**
 * 用来处理 weex 下，同时有 borderWidth 和 borderTopWidth 时，weex 表现异常的问题
 * @param {object} style
 * @param {array} attrArray 需要修复 border 的哪些属性
 * @return {object} style
 */
export function borderSeperate(style, attrs = ['Color', 'Style', 'Width']) {
  if (style.border) {
    if (style.border === 'none') {
      style.borderWidth = 0;
    }
    delete style.border;
  }
  attrs.map((attr) => {
    if (style.hasOwnProperty(`border${attr}`)) {
      const attrObj = {
        [`borderTop${attr}`]: style[`border${attr}`],
        [`borderLeft${attr}`]: style[`border${attr}`],
        [`borderRight${attr}`]: style[`border${attr}`],
        [`borderBottom${attr}`]: style[`border${attr}`],
      };
      let deleteFlag = false;
      ['Top', 'Left', 'Right', 'Bottom'].map((direction) => {
        if (style.hasOwnProperty(`border${direction}${attr}`)) {
          deleteFlag = true;
          attrObj[`border${direction}${attr}`] = style[`border${direction}${attr}`];
        }
      });
      if (deleteFlag) {
        delete style[`border${attr}`];
        style = Object.assign({}, attrObj, style);
      }
    }
  });
  return style;
}
